/* rudimentale portscan per Windows, Linux, e FreeBSD */

/*
Come compilare:

In Linux, FreeBSD, o in CygWin, compilare con:
    gcc PortScan.c  -o Portscan
    
Im ambiente Windows, avendo il compilatore MinGW compilare con:
    
    
    mingw32-gcc PortScan.c -o PortScan.exe -mconsole -mwindows -lws2_32
    
( Nota:** da linea di comando si deve specificare il file di output con l'opzione -o 
o viene generato di default l'eseguibile a.exe.

Con l'IDE DevCpp passare le seguenti informazioni (Menu Tools /Compiler Options)
Al compilatore: -mconsole -mwindows
Al linker: -lws2_32

  */


#ifdef _WIN32
    #include<winsock.h>
    WSADATA wsaData;
    WORD    wVersionRequested;
#else
    #include<sys/socket.h>
    /* per SOCK_STREAM, AF_INET, struct sockaddr{}, e socket() */
    #include<sys/types.h>
    #include<netinet/in.h>
    /*per struct sockaddr_in{}, struct in_addr */
#endif    
#define BUFSIZ          255

#include<time.h> /*per ctime(), time_t */
void header(time_t);
void init_socket(struct sockaddr_in *,int,long);

#include<stdio.h> /*per printf(), puts(), popen()*/
#include<stdlib.h>/*per exit() */


int main(void){
    
char* PATH="scan.dat";
/* file di log */
    
char IP_ADDRESS[10]="127.0.0.1";
/*indirizzo IP: modificare eventualmente */

int PORT,iport,fport,choice,ret,sockd;
/*porta nel ciclo, porta iniziale, porta finale, scelta, codice di ritorno scanf(), descrittore socket */
time_t t;  
#ifdef _WIN32
       char *cmd = "ver";
#else  
       char *cmd = "uname -a";
#endif  
/* comando per sapere il sistema operativo in cui il programma  in uso 
si ipotizza che il programma giri su Windows o sistemi Unix */

char buf[BUFSIZ];
/* buffer per popen() */

FILE *ptr,*file_ptr; /*descrittore file per popen e il file di log */
                        
struct sockaddr_in server_address;
/*struttura che contiene le informazioni di una connessione socket locale o remota

sin_family
    Address family (must be AF_INET).
sin_port
    IP port.
sin_addr
    IP address.
sin_zero
    Padding to make structure the same size as SOCKADDR. 
    
    
    */ 
       
#ifdef _WIN32
    wVersionRequested=MAKEWORD(2,2);
    /*
    
    funzione definita in ws_32.DLL
    wVersionRequested
    
    [in] Highest version of Windows Sockets support that the caller can use. 
    The high-order byte specifies the minor version (revision) number; the low-order
     byte specifies the major version number.
     
     lpWSAData
    [out] Pointer to the "WSADATA" data structure that is to receive details of the 
    Windows Sockets implementation. 
    
    The MAKEWORD macro creates a WORD value by concatenating the specified values.

    Syntax

    WORD MAKEWORD(


        BYTE bLow,
        BYTE bHigh
                );

    
    */
    
    /* inizializzazione della winsock     
       questo viene fatto solo su windows dato che
       non esiste il dispositivo socket come in Linux
       
       
    WSAStartup  definita in  ws_32.DLL */
       
if(WSAStartup(wVersionRequested,&wsaData)<0){
    printf("Impossibile inizializzare Winsock: %d",WSAGetLastError());       
         
    exit(1);
        /* ritorna 0 se l'inizializzazione avviene con successo */
        
                                   } 
                                              
#endif

header(t);

do{
   puts("1.Voglio salvare i risultati in un file.\n2.Voglio solo visualizzare i risultati.\n3.Voglio uscire o non sono d'accordo sul modo d'uso e sulla licenza.");
   ret=scanf("%d",&choice);

   if(!ret)
           invalid_input();

     if(choice<1 || choice>3)
           puts("\nScelta non valida!\n");

}while(choice<1 || choice>3);

if(choice==3)
    return 0;
    
puts("Inserisci il range delle porte da scansionare: \n");

do{
   puts("\nNumero di porta iniziale: ");
   ret=scanf("%d",&iport);

   if(!ret)
        invalid_input();
    
    if(iport <0 || iport>65535)  
        puts("\nInserire un numero tra 0 e 65535"); 


}while(iport<0 || iport>65535);

do{
   puts("\nNumero di porta finale: ");

   ret=scanf("%d",&fport);

   if(!ret)
              invalid_input();
     
     if(fport <0 || fport>65535)  
              puts("\nInserire un numero tra 0 e 65535!"); 
 

if(fport<iport)
    puts("\nIl numero di porta finale deve essere maggiore o uguale a quello della porta iniziale!");     
}while(fport<0 || fport>65535 || fport<iport);


if(choice==1){
                     
    if((file_ptr=fopen(PATH,"a+") )){  
   	     fprintf(file_ptr,"=====================================\n");     
    if(ferror(file_ptr)){                  
         perror("Errore durante scrittura del file: ");
         return -1;					}  
               
    fprintf(file_ptr,"Portscan personale\n");
		
    if(ferror(file_ptr)){        
        perror("Errore durante la scrittura del file: ");
		return -1;
                           } 
     
		
    time(&t);        
       
    fprintf(file_ptr,"%s",ctime(&t)) ;
    if(ferror(file_ptr)){  
        perror("Errore durante la scrittura del file: ");
        return -1;
                        }          
  
    if ((ptr = popen(cmd, "r")) != NULL)
         while (fgets(buf, BUFSIZ, ptr) != NULL)
             fprintf(file_ptr,"%s\n",buf);
             if(ptr)
                    fclose(ptr);
/* popen(), funzione per creare un collegamento tra l programma e il processo e/o
comando da esso chiamato. Ci serve per recuperare l'output del comando */   

    if(ferror(file_ptr)){  
        perror("Errore durante la scrittura del file: ");
        return -1;
                        }      
                                        
    fprintf(file_ptr,"Porta iniziale: %d\n",iport);
   
    if(ferror(file_ptr)){
		perror("Errore durante la scrittura del file: ");
		return -1;          
                        }    
     
                    
      
    fprintf(file_ptr,"Porta finale: %d\n",fport);
    if(ferror(file_ptr)){         
			perror("Errore durante la scrittura del file: ");
			return -1;   
                        } 
      
    fprintf(file_ptr,"Host: %s\n",IP_ADDRESS);
           
	if(ferror(file_ptr)){         
			perror("Errore durante la scrittura del file: ");
			return -1;   
                           } 
                       }
     
else{
    perror("Errore durante l'apertura del file in scrittura: ");
    exit(1);
      }                          
 
  }
  
puts("\aScansione iniziata...\n");
for(PORT=iport;PORT<=fport;PORT++) { /*ciclo per il range */
    
    init_socket(&server_address,PORT,inet_addr(IP_ADDRESS));
    /*riempiamo le variabili della struttura */
    
        /*creazione di  un socket*/

    if(sockd=socket(AF_INET,SOCK_STREAM,0)){
    
    /* creiamo un socket collegato ad uno specifico protocollo
    
    AF_INET
    specifies ARPA Internet protocols.

    AF_UNIX
    specifies UNIX domain protocols. (Only used with integrated sockets.)
    
    
    SOCK_STREAM 	
    Provides sequenced, reliable, two-way, connection-based byte streams with an OOB
     data transmission mechanism. Uses TCP for the Internet address family.
     
     SOCK_DGRAM 	Supports datagrams, which are connectionless, unreliable buffers
     of a fixed (typically small) maximum length. Uses UDP for the Internet address 
     family.

    SOCK_RAW
    provides access to low-level network protocols and interfaces.
    
    0=default protocol number for the socket domain and type specified
        
   */  
	if(!(connect(sockd,(struct sockaddr*) &server_address,sizeof(server_address)))) 

 /*tentativo di chiamata */
  
      { 
          
          
    /*il server ci risponde*/
    
         printf("Porta %d aperta\n",PORT);  
      
     //chiusura del socket connesso
     
          #ifdef _WIN32
                closesocket(sockd);
                    #else
                close(sockd);
         #endif
         
		if(choice==1){				
				fprintf(file_ptr,"Porta %d aperta\n",PORT);
         		if(ferror(file_ptr)){         
				         perror("Errore durante la scrittura del file: ");
				return -1;   
									}   
         
						}
	}     /*il server non ha risposto alla chiamata*/  
	
		else{
			    printf("Porta %d chiusa\n",PORT);
				#ifdef _WIN32
                closesocket(sockd);
				#else
                close(sockd);
				#endif
			    }
      }
      
   
   }
       #ifdef _WIN32
                WSACleanup();
       /*liberiamo la memoria allocata dalla winsock */
       #endif
	   
printf("\aScansione terminata");
if(choice==1) {  
    fprintf(file_ptr,"Scansione terminata!\n") ;
          
    if(ferror(file_ptr)){
         
		perror("Errore durante la scrittura del file: ");
		return -1;   
                              }       
                           
                                     
       
time(&t);
        
      
fprintf(file_ptr,"%s",ctime(&t)) ;
          
    if(ferror(file_ptr)){         
        perror("Errore durante la scrittura del file: ");
        return -1;  
                        }     
							
       if(file_ptr)
		 fclose(file_ptr);	   
	   			
       puts("\nSessione salvata!\n");              
        }                      
                     
   
   return 0;  
} 
    

        
            
void header(time_t t){
time(&t);        
printf("%s",ctime(&t)); 
printf("portscan versione 0.l\n");    
puts("Autore: Fabrizio Pani (c) - e-mail: fabph@hotmail.com");
puts("Sorgente distribuito secondo licenza GPL: vedi i file");
puts("\"license.txt\" e  \"licenza.txt\" per maggiori dettagli");
puts("");
puts("Portscan elementare distribuito secondo licenza GPL.");
puts("Nessuna garanzia implicita o esplicita, lo usi a tuo rischio!");
puts("");
puts("Non responsabile per eventuale usi illeciti.");
puts("Il software e` stato concepito con il solo scopo di sapere quali") ;
puts("porte sono aperte nel proprio sistema o nella propria rete LAN, e come");
puts("esempio didattico di programmazione con i socket, in linguaggio C."); 
puts("");
puts("Se non sei d'accordo non usarlo e cancellalo subito!");
puts("Ad ogni modo il codice originale funziona solo in localhost.\n");

}
    

void init_socket(struct sockaddr_in * address,int port,long IPaddr){
address->sin_family=AF_INET;
address->sin_port=htons((u_short) port);
address->sin_addr.s_addr=IPaddr;
return;

}

invalid_input(){
    
    puts("\nIl valore inserito non e` valido!");
    exit(-1);
                }    
  
      

            
   
